#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifndef PI
#define PI 3.141592687
#endif
//unsere variablen !

#define MAX_MATERIALS 300
#define MAX_VERTICES 5000
#define MAX_FACES 5000
#define MAX_OBJS 300

char huge MAT_name    [MAX_MATERIALS] [30];
int  huge MAT_map_nr  [MAX_MATERIALS]={0};
char huge MAT_maptype [MAX_MATERIALS][8] [30];
char huge MAT_mapfile [MAX_MATERIALS][8] [30];
int MAT_nr=0;

float huge VERT_xyzuv [MAX_VERTICES] [5];         //x,y,z,u,v
int        VERT_nr=0;

int  huge FACE_123  [MAX_FACES] [3];              //1ecke,2ecke,3ecke,
char huge FACE_matname [MAX_FACES] [30];//materialname
int       FACE_nr=0;

char huge OBJ_name       [MAX_OBJS] [30];      //name des Objs
int  huge OBJ_aeVertices [MAX_OBJS] [2];  //anfang ende der vertices des Objs
int  huge OBJ_aeFaces    [MAX_OBJS] [2];  //anfang ende der faces des Objs
int       OBJ_nr=0;

FILE *out;

char hilfname[30];
char hilfobjname[30];
//ende unsere variablen !

int Unknow   = 0;
int Ruhe     = 0;

typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long  dword;

typedef signed char  sbyte;
typedef signed short sword;
typedef signed long  sdword;

#pragma pack(2)

typedef struct {
    word    id;
    dword   len;
} TChunkHeader, *PChunkHeader;

#pragma pack()

enum {
    CHUNK_RGBF      = 0x0010,
    CHUNK_RGBB      = 0x0011,
//    CHUNK_RBGB2     = 0x0012,       // ?? NOT HLS.

    CHUNK_PRJ       = 0xC23D,
    CHUNK_MLI       = 0x3DAA,

    CHUNK_MAIN      = 0x4D4D,
	CHUNK_OBJMESH   = 0x3D3D,
	    CHUNK_BKGCOLOR  = 0x1200,
	    CHUNK_AMBCOLOR  = 0x2100,
	    CHUNK_OBJBLOCK  = 0x4000,
		CHUNK_TRIMESH   = 0x4100,
//		    CHUNK_VERTLIST  = 0x4110,
//		    CHUNK_FACELIST  = 0x4120,
		    CHUNK_FACEMAT   = 0x4130,
		    CHUNK_MAPLIST   = 0x4140,
		    CHUNK_SMOOLIST  = 0x4150,
		    CHUNK_TRMATRIX  = 0x4160,
		CHUNK_LIGHT     = 0x4600,
		    CHUNK_SPOTLIGHT = 0x4610,
		CHUNK_CAMERA    = 0x4700,
		CHUNK_HIERARCHY = 0x4F00,
	CHUNK_VIEWPORT  = 0x7001,
	CHUNK_MATERIAL  = 0xAFFF,
	    CHUNK_MATNAME   = 0xA000,
	    CHUNK_AMBIENT   = 0xA010,
	    CHUNK_DIFFUSE   = 0xA020,
	    CHUNK_SPECULAR  = 0xA030,
	    CHUNK_TEXTURE1  = 0xA200,
	    CHUNK_TEXTURE2  = 0xA33A,
	    CHUNK_SHININESS = 0xA33C,
	    CHUNK_SPECUMAP  = 0xA204,
	    CHUNK_OPACMAP   = 0xA210,
	    CHUNK_SELFILMAP = 0xA33D,
	    CHUNK_REFLECT   = 0xA220,
	    CHUNK_BUMPMAP   = 0xA230,
            CHUNK_MAPFILE   = 0xA300,
        CHUNK_KEYFRAMER = 0xB000,
            CHUNK_AMBIENTKEY    = 0xB001,
            CHUNK_TRACKINFO = 0xB002,
                CHUNK_TRACKOBJNAME  = 0xB010,
                CHUNK_TRACKPIVOT    = 0xB013,
		CHUNK_TRACKPOS      = 0xB020,
                CHUNK_TRACKROTATE   = 0xB021,
                CHUNK_TRACKSCALE    = 0xB022,
                CHUNK_OBJNUMBER     = 0xB030,
            CHUNK_TRACKCAMERA = 0xB003,
                CHUNK_TRACKFOV  = 0xB023,
                CHUNK_TRACKROLL = 0xB024,
            CHUNK_TRACKCAMTGT = 0xB004,
	    CHUNK_TRACKLIGHT  = 0xB005,
	    CHUNK_TRACKLIGTGT = 0xB006,
	    CHUNK_TRACKSPOTL  = 0xB007,
	    CHUNK_FRAMES    = 0xB008,


};

// ------------------------------------

    // Forward declaration.
void ChunkReader(FILE *f, int ind, long p);

void SkipReader(FILE *f, int ind, long p) {
}

void RGBFReader (FILE *f, int ind, long p) {
    float c[3];
    if (!Ruhe) fprintf(out,"--->RGBFReader  \n");
    if (fread(&c, sizeof(c), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s    Red: %f, Green: %f, Blue: %f\n", ind, "", c[0], c[1], c[2]);
}

void RGBBReader (FILE *f, int ind, long p) {
    byte c[3];
    if (!Ruhe) fprintf(out,"--->RGBBReader   \n");
    if (fread(&c, sizeof(c), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s    Red: %d, Green: %d, Blue: %d\n", ind, "", c[0], c[1], c[2]);
}

void ASCIIZReader (FILE *f, int ind, long p) {
    char hilfstr[30];
    int i=0;

	// Read ASCIIZ name
    while ((hilfstr[i] = fgetc(f)) != EOF && hilfstr[i] != '\0') i++;
    if (!Ruhe) fprintf(out,"%s\"\n",hilfstr);
    strcpy(hilfname,hilfstr);
}

void ObjBlockReader (FILE *f, int ind, long p) {
    int c,i;

    if (!Ruhe) fprintf(out,"--->ObjBlockReader \n");
	// Read ASCIIZ object name
    if (!Ruhe) fprintf(out,"%*sObject name \"", ind, "");
    ASCIIZReader(f, ind, p);
	// Read rest of chunks inside this one.

    sprintf(hilfobjname,hilfname);
    ChunkReader(f, ind, p);
}

void TriMeshReader(FILE *f, int ind, long p) {
 int i;

    if (!Ruhe) fprintf(out,"--->TriMeshReader \n");
    for (i=0;i<30;i++)  OBJ_name[OBJ_nr][i] = hilfobjname[i];
    printf("...%Fs\n",OBJ_name[OBJ_nr]);
    ChunkReader(f, ind, p);
    OBJ_nr++;
}

void VertListReader (FILE *f, int ind, long p) {
    word nv;
    float c[3];

    if (!Ruhe) fprintf(out,"--->VertListReader  \n");
    OBJ_aeVertices [OBJ_nr][0]=VERT_nr;  //anfang ende der vertices des Objs
    if (fread(&nv, sizeof(nv), 1, f) != 1) return;

    if (!Ruhe) fprintf(out,"%*sVertices: %d\n", ind, "", nv);
    while (nv-- > 0) {
	if (fread(&c, sizeof(c), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s    X: %f, Y: %f, Z: %f\n", ind, "", c[0], c[1], c[2]);

	VERT_xyzuv[VERT_nr][0]=c[0];
	VERT_xyzuv[VERT_nr][1]=c[1];
	VERT_xyzuv[VERT_nr][2]=c[2];
	VERT_nr++;
    }
  OBJ_aeVertices [OBJ_nr][1]=VERT_nr-1;  //ende der vertices des Objs

}

void FaceListReader (FILE *f, int ind, long p) {
    word nv;
    word c[3];
    word flags;

    if (!Ruhe) fprintf(out,"--->FaceListReader  \n");

    OBJ_aeFaces[OBJ_nr][0]=FACE_nr;
    if (fread(&nv, sizeof(nv), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sFaces: %d\n", ind, "", nv);
    while (nv-- > 0) {
	if (fread(&c, sizeof(c), 1, f) != 1) return;
	if (fread(&flags, sizeof(flags), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s  A %d, B %d, C %d, 0x%X:",
	       ind, "", c[0], c[1], c[2], flags);
//        if (!Ruhe) fprintf(out,"%*s    AB: %d, BC: %d, CA: %d, UWrap %d, VWrap %d\n",
//               ind, "",
	if (!Ruhe) fprintf(out," AB %d BC %d CA %d UWrap %d VWrap %d\n",
	       (flags & 0x04) != 0, (flags & 0x02) != 0, (flags & 0x01) != 0,
	       (flags & 0x08) != 0, (flags & 0x10) != 0);

	FACE_123[FACE_nr][0]=c[0];
	FACE_123[FACE_nr][1]=c[1];
	FACE_123[FACE_nr][2]=c[2];
	FACE_nr++;
    }
	// Read rest of chunks inside this one.
    OBJ_aeFaces[OBJ_nr][1]=FACE_nr-1;

    ChunkReader(f, ind, p);
}

void FaceMatReader (FILE *f, int ind, long p) {
    int h,i,c;
    word n, nf;
    char hilfstr1[30],hilfstr2[30];

	// Read ASCIIZ material name
    if (!Ruhe) fprintf(out,"---> FaceMatReader \n");

    FACE_nr=OBJ_aeFaces[OBJ_nr][0];

    if (!Ruhe) fprintf(out,"%*sMaterial name for faces: \"", ind, "");
    ASCIIZReader(f, ind, p);
    if (fread(&n, sizeof(n), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sFaces with this material: %d\n", ind, "", n);
    while (n-- > 0) {
	if (fread(&nf, sizeof(nf), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s    Face %d\n",
	       ind, "", nf);

	for (i=0;i<30;i++) FACE_matname[FACE_nr][i] = hilfname[i];

	FACE_nr++;
    }
    FACE_nr=OBJ_aeFaces[OBJ_nr][1]+1;

}

void MapListReader (FILE *f, int ind, long p) {
    word nv;
    float c[2];

    if (!Ruhe) fprintf(out,"--->MapListReader  \n");

    VERT_nr=OBJ_aeVertices [OBJ_nr][0];  //anfang ende der vertices des Objs

    if (fread(&nv, sizeof(nv), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sVertices: %d\n", ind, "", nv);
    while (nv-- > 0) {
	if (fread(&c, sizeof(c), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s    U: %f, V: %f\n", ind, "", c[0], c[1]);
        VERT_xyzuv[VERT_nr][3]=c[0];
	VERT_xyzuv[VERT_nr][4]=c[1];
	VERT_nr++;
    }
}

void SmooListReader (FILE *f, int ind, long p) {
    dword s;
    int i;

    if (!Ruhe) fprintf(out,"--->SmooListReader  \n");
    while (ftell(f) < p) {
	if (fread(&s, sizeof(s), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*sSmoothing groups: ", ind, "");
	for (i = 0; i < 32; i++)
	    if (s & (1 << i))
		if (!Ruhe) fprintf(out,"%d, ", i + 1);
	if (!Ruhe) fprintf(out,"\n");
    }
}

void TrMatrixReader(FILE *f, int ind, long p) {
    float rot[9];
    float trans[3];

    if (!Ruhe) fprintf(out,"--->TrMatrixReader \n");
    if (fread(&rot, sizeof(rot), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sRotation matrix:\n", ind, "");
    if (!Ruhe) fprintf(out,"%*s    %f, %f, %f\n", ind, "", rot[0], rot[1], rot[2]);
    if (!Ruhe) fprintf(out,"%*s    %f, %f, %f\n", ind, "", rot[3], rot[4], rot[5]);
    if (!Ruhe) fprintf(out,"%*s    %f, %f, %f\n", ind, "", rot[6], rot[7], rot[8]);
    if (fread(&trans, sizeof(trans), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sTranslation matrix: %f, %f, %f\n",
	   ind, "", trans[0], trans[1], trans[2]);
}

void LightReader(FILE *f, int ind, long p) {
    float c[3];

    if (!Ruhe) fprintf(out,"--->LightReader \n");
    if (fread(&c, sizeof(c), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s    X: %f, Y: %f, Z: %f\n", ind, "", c[0], c[1], c[2]);
	// Read rest of chunks inside this one.
    ChunkReader(f, ind, p);
}

void SpotLightReader(FILE *f, int ind, long p) {
    float c[5];
    if (!Ruhe) fprintf(out,"--->SpotLightReader \n");
    if (fread(&c, sizeof(c), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s    Target X: %f, Y: %f, Z: %f; Hotspot %f, Falloff %f\n",
	   ind, "", c[0], c[1], c[2], c[3], c[4]);
}

void CameraReader(FILE *f, int ind, long p) {
    float c[8];
    if (!Ruhe) fprintf(out,"--->CameraReader \n");
    if (fread(&c, sizeof(c), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s    Position: X: %f, Y: %f, Z: %f\n", ind, "", c[0], c[1], c[2]);
    if (!Ruhe) fprintf(out,"%*s    Target: X: %f, Y: %f, Z: %f\n", ind, "", c[3], c[4], c[5]);
    if (!Ruhe) fprintf(out,"%*s    Bank: %f, Lens: %f\n", ind, "", c[6], c[7]);
}

void MatNameReader (FILE *f, int ind, long p) {
    int i,c;

	// Read ASCIIZ object name
    if (!Ruhe) fprintf(out,"--->MatNameReader \n");
    if (!Ruhe) fprintf(out,"%*sMaterial name \"", ind, "");
    ASCIIZReader(f, ind, p);
    for (i=0;i<30;i++) MAT_name[MAT_nr][i] = hilfname[i];
    MAT_nr++;
}

void MapFileReader(FILE *f, int ind, long p) {
    int c,i;

	// Read ASCIIZ filename
    if (!Ruhe) fprintf(out,"--->MapFileReader \n");
    if (!Ruhe) fprintf(out,"%*sMap filename \"", ind, "");
    ASCIIZReader(f, ind, p);
    for (i=0;i<30;i++) MAT_mapfile[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
			 = hilfname[i];
}

void TextureMapReader1(FILE *f, int ind, long p) {
    int c,i;

    if (!Ruhe) fprintf(out,"--->TextureMapReader1 \n");
    sprintf(hilfname,"Texture map 1");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
			    = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void TextureMapReader2(FILE *f, int ind, long p) {
    int c,i;

    if (!Ruhe) fprintf(out,"--->TextureMapReader2 \n");
    sprintf(hilfname,"Texture map 2");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
			    = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void ShininessMapReader(FILE *f, int ind, long p) {
    int c,i;

    if (!Ruhe) fprintf(out,"--->ShininessMapReader \n");
    sprintf(hilfname,"Shininess map");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
			    = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}


void SpecularMapReader(FILE *f, int ind, long p) {
    int c,i;

    if (!Ruhe) fprintf(out,"--->SpecularMapReader \n");
    sprintf(hilfname,"Specular map");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
			    = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void OpacityMapReader(FILE *f, int ind, long p) {
    int c,i;
    if (!Ruhe) fprintf(out,"--->OpacityMapReader \n");
    sprintf(hilfname,"Opacity map");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
		       = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void SelfillumMapReader(FILE *f, int ind, long p) {
    int c,i;
    if (!Ruhe) fprintf(out,"--->SelfillumMapReader \n");
    sprintf(hilfname,"Self Illum map");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
		       = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void ReflectionMapReader(FILE *f, int ind, long p) {
    int c,i;
    if (!Ruhe) fprintf(out,"--->ReflectionMapReader \n");
    sprintf(hilfname,"Reflection map");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
		       = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void BumpMapReader(FILE *f, int ind, long p) {
    int c,i;
    if (!Ruhe) fprintf(out,"--->BumpMapReader \n");
    sprintf(hilfname,"Bump map");
    for (i=0;i<30;i++) MAT_maptype[MAT_nr-1] [MAT_map_nr[MAT_nr-1]] [i]
		       = hilfname[i];
    ChunkReader(f, ind, p);
    MAT_map_nr[MAT_nr-1]++;
}

void FramesReader(FILE *f, int ind, long p) {
    dword c[2];
    if (!Ruhe) fprintf(out,"--->FramesReader \n");
    if (fread(&c, sizeof(c), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s    Start: %ld, End: %ld\n",
	   ind, "", c[0], c[1]);
}

void TrackObjNameReader(FILE *f, int ind, long p) {
    int c;
    word w[2];
    word parent;

	// Read ASCIIZ name
    if (!Ruhe) fprintf(out,"--->TrackObjNameReader \n");
    if (!Ruhe) fprintf(out,"%*sTrack object name \"", ind, "");
    ASCIIZReader(f, ind, p);
    if (fread(&w, sizeof(w), 1, f) != 1) return;
    if (fread(&parent, sizeof(parent), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sObject name data: Flags 0x%X, 0x%X, Parent %d\n",
	   ind, "", w[0], w[1], parent);
}

void PivotPointReader(FILE *f, int ind, long p) {
    float pos[3];

    if (!Ruhe) fprintf(out,"--->PivotPointReader \n");
    if (fread(&pos, sizeof(pos), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*s  Pivot at X: %f, Y: %f, Z: %f\n",
	   ind, "",
	   pos[0], pos[1], pos[2]);
}

    /* Key info flags for position, rotation and scaling:
	Until I know the meaning of each bit in flags I assume all mean
	a following float data.
    */

	// NOTE THIS IS NOT A CHUNK, but A PART OF SEVERAL CHUNKS
void SplineFlagsReader(FILE *f, int ind, word flags) {
    int i;
    float dat;

    if (!Ruhe) fprintf(out,"--->SplineFlagsReader \n");
    for (i = 0; i < 16; i++) {
	static const char *flagnames[] = {
	    "Tension",
	    "Continuity",
	    "Bias",
	    "Ease To",
	    "Ease From",
	};
	if (flags & (1 << i)) {
	    if (fread(&dat, sizeof(dat), 1, f) != 1) return;
	    if (i < sizeof(flagnames)/sizeof(*flagnames))
		if (!Ruhe) fprintf(out,"%*s             %-15s = %f\n",
		       ind, "", flagnames[i], dat);
	    else
		if (!Ruhe) fprintf(out,"%*s             %-15s = %f\n",
		       ind, "", "Unknown", dat);
	}
    }
}

void TrackPosReader(FILE *f, int ind, long p) {
    word n, nf;
    float pos[3];
    word unkown;
    word flags;

    if (!Ruhe) fprintf(out,"--->TrackPosReader \n");
    fseek(f, 10, SEEK_CUR);
    if (fread(&n, sizeof(n), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sPosition keys: %d\n", ind, "", n);
    fseek(f, 2, SEEK_CUR);
    while (n-- > 0) {
	if (fread(&nf, sizeof(nf), 1, f) != 1) return;
	if (fread(&unkown, sizeof(unkown), 1, f) != 1) return;
	if (fread(&flags, sizeof(flags), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s  Frame %3d: Flags 0x%X\n", ind, "", nf, flags);
	SplineFlagsReader(f, ind, flags);
	if (fread(&pos, sizeof(pos), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s             X: %f, Y: %f, Z: %f\n",
	       ind, "", pos[0], pos[1], pos[2]);
    }
}

void TrackRotReader(FILE *f, int ind, long p) {
    word n, nf;
    float pos[4];
    word unkown;
    word flags;

    if (!Ruhe) fprintf(out,"--->TrackRotReader \n");
    fseek(f, 10, SEEK_CUR);
    if (fread(&n, sizeof(n), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sRotation keys: %d\n", ind, "", n);
    fseek(f, 2, SEEK_CUR);
    while (n-- > 0) {
	if (fread(&nf, sizeof(nf), 1, f) != 1) return;
	if (fread(&unkown, sizeof(unkown), 1, f) != 1) return;
	if (fread(&flags, sizeof(flags), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s  Frame %3d: Flags 0x%X\n", ind, "", nf, flags);
	SplineFlagsReader(f, ind, flags);
	if (fread(&pos, sizeof(pos), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s             Angle: %f, X: %f, Y: %f, Z: %f\n",
	       ind, "", pos[0]*180.0/PI, pos[1], pos[2], pos[3]);
    }
}

void TrackScaleReader(FILE *f, int ind, long p) {
    word n, nf;
    float pos[3];
    word unkown;
    word flags;

    if (!Ruhe) fprintf(out,"--->TrackScaleReader \n");
    fseek(f, 10, SEEK_CUR);
    if (fread(&n, sizeof(n), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sScale keys: %d\n", ind, "", n);
    fseek(f, 2, SEEK_CUR);
    while (n-- > 0) {
	if (fread(&nf, sizeof(nf), 1, f) != 1) return;
	if (fread(&unkown, sizeof(unkown), 1, f) != 1) return;
	if (fread(&flags, sizeof(flags), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s  Frame %3d: Flags 0x%X\n", ind, "", nf, flags);
	SplineFlagsReader(f, ind, flags);
	if (fread(&pos, sizeof(pos), 1, f) != 1) return;
	if (!Ruhe) fprintf(out,"%*s            X: %f, Y: %f, Z: %f\n",
	       ind, "", pos[0], pos[1], pos[2]);
    }
}

void ObjNumberReader(FILE *f, int ind, long p) {
    word n;

    if (!Ruhe) fprintf(out,"--->ObjNumberReader \n");
    if (fread(&n, sizeof(n), 1, f) != 1) return;
    if (!Ruhe) fprintf(out,"%*sObject number: %d\n", ind, "", n);
}


// ------------------------------------

struct {
    word id;
    const char *name;
    void (*func)(FILE *f, int ind, long p);
} ChunkNames[] = {
    {CHUNK_RGBF,        "RGB float",        RGBFReader},
    {CHUNK_RGBB,        "RGB byte",         RGBBReader},

    {CHUNK_PRJ,         "Project",          NULL},
    {CHUNK_MLI,         "Material Library", NULL},

    {CHUNK_MAIN,        "Main",             NULL},
    {CHUNK_OBJMESH,     "Object Mesh",      NULL},
    {CHUNK_BKGCOLOR,    "Background color", NULL},
    {CHUNK_AMBCOLOR,    "Ambient color",    NULL},
    {CHUNK_OBJBLOCK,    "Object Block",     ObjBlockReader},
    {CHUNK_TRIMESH,     "Tri-Mesh",         TriMeshReader},
//  {CHUNK_VERTLIST,    "Vertex list",      VertListReader},
//  {CHUNK_FACELIST,    "Face list",        FaceListReader},
    {CHUNK_FACEMAT,     "Face material",    FaceMatReader},
    {CHUNK_MAPLIST,     "Mappings list",    MapListReader},
    {CHUNK_SMOOLIST,    "Smoothings",       SmooListReader},
    {CHUNK_TRMATRIX,    "Matrix",           TrMatrixReader},
    {CHUNK_LIGHT,       "Light",            LightReader},
//    {CHUNK_LIGHT,       "Light",            NULL},
    {CHUNK_SPOTLIGHT,   "Spotlight",        SpotLightReader},
//    {CHUNK_SPOTLIGHT,   "Spotlight",        NULL},
    {CHUNK_CAMERA,      "Camera",           CameraReader},
//    {CHUNK_CAMERA,      "Camera",           NULL},
    {CHUNK_HIERARCHY,   "Hierarchy",        NULL},

    {CHUNK_VIEWPORT,    "Viewport info",    NULL},
    {CHUNK_MATERIAL,    "Material",         NULL},
    {CHUNK_MATNAME,     "Material name",    MatNameReader},
    {CHUNK_AMBIENT,     "Ambient color",    NULL},
    {CHUNK_DIFFUSE,     "Diffuse color",    NULL},
    {CHUNK_SPECULAR,    "Specular color",   NULL},
    {CHUNK_TEXTURE1,    "Texture map1",     TextureMapReader1},
    {CHUNK_TEXTURE2,    "Texture map2",     TextureMapReader2},//new !
    {CHUNK_SHININESS,   "Shininess map",    ShininessMapReader},//new !
    {CHUNK_SPECUMAP,    "Specular map",     SpecularMapReader},//new !
    {CHUNK_OPACMAP,     "Opacity map",      OpacityMapReader},//new !
    {CHUNK_SELFILMAP,   "Self Illum map",   SelfillumMapReader},//new !
    {CHUNK_REFLECT,     "Reflection Map",   ReflectionMapReader},//new !
    {CHUNK_BUMPMAP,     "Bump map",         BumpMapReader},
    {CHUNK_MAPFILE,     "Map filename",     MapFileReader},

    {CHUNK_KEYFRAMER,   "Keyframer data",   NULL},
    {CHUNK_AMBIENTKEY,  "Ambient key",      NULL},
    {CHUNK_TRACKINFO,   "Track info",       NULL},
    {CHUNK_FRAMES,      "Frames",           FramesReader},
    {CHUNK_TRACKOBJNAME,"Track Obj. Name",  TrackObjNameReader},
    {CHUNK_TRACKPIVOT,  "Pivot point",      PivotPointReader},
    {CHUNK_TRACKPOS,    "Position keys",    TrackPosReader},
    {CHUNK_TRACKROTATE, "Rotation keys",    TrackRotReader},
    {CHUNK_TRACKSCALE,  "Scale keys",       TrackScaleReader},
    {CHUNK_OBJNUMBER,   "Object number",    ObjNumberReader},

    {CHUNK_TRACKCAMERA, "Camera track",             NULL},
    {CHUNK_TRACKCAMTGT, "Camera target track",      NULL},
    {CHUNK_TRACKLIGHT,  "Pointlight track",         NULL},
    {CHUNK_TRACKLIGTGT, "Pointlight target track",  NULL},
    {CHUNK_TRACKSPOTL,  "Spotlight track",          NULL},
    {CHUNK_TRACKFOV,    "FOV track",                NULL},
    {CHUNK_TRACKROLL,   "Roll track",               NULL},
};

int FindChunk(word id) {
    int i;
    for (i = 0; i < sizeof(ChunkNames)/sizeof(ChunkNames[0]); i++)
	if (id == ChunkNames[i].id)
	    return i;
    return -1;
}

// ------------------------------------

void ChunkReader(FILE *f, int ind, long p) {
    TChunkHeader h;
    int n;
    long pc;

    while (ftell(f) < p) {
	pc = ftell(f);
	if (fread(&h, sizeof(h), 1, f) != 1) return;
	if (h.len == 0) return;
	n = FindChunk(h.id);
	if (n < 0) {
	    if (Unknow && !Ruhe)
		fprintf(out,"%*sUnknown chunk: 0x%04X, offset 0x%lX, size: %d bytes.\n",
		       ind, "", h.id, pc, h.len);
	    fseek(f, pc + h.len, SEEK_SET);
	} else {
	    if ((!Ruhe) && (ChunkNames[n].func == NULL))
		fprintf(out,"\"chunk %s\"\n",ChunkNames[n].name);
//		fprintf(out,"%*sChunk type \"%s\", offset 0x%lX, size %d bytes\n",
//		       ind, "", ChunkNames[n].name, pc, h.len);
	    pc = pc + h.len;
	    if (ChunkNames[n].func != NULL)
                ChunkNames[n].func(f, ind + 2, pc);
            else
		ChunkReader(f, ind + 2, pc);
		   fseek(f, pc, SEEK_SET);
        }
	if (ferror(f))
	    break;
    }
}

// ------------------------------------

void Banner(void) {
    printf("3DSR, 3D Studio formats reader v0.0 by Foenyx (ST90) \n\n");
}

void main(int argc, char *argv[]) {
    FILE *f;
    int i,j,fehler=0;
    long p;

    if (argc < 2) {
	Banner();
	printf("3DSR file.3DS [-ruhe or -unknown] \n");
	printf("Optionen: \n");
	printf("       -unknow : keine meldung von unbekannten chunks in 3dsr.foe \n");
	printf("       -ruhe   : keine Ausgabe in 3dsr.foe \n");
	exit(1);
    }

    f = fopen(argv[1], "rb");
    if (f == NULL) {
	Banner();
	printf("Can't open %s!\n", argv[1]);
	exit(1);
    }

    if (argc > 2 && strcmp(argv[2], "-unknow") == 0)
	Unknow = 1;
    if (argc > 2 && strcmp(argv[2], "-ruhe") == 0)
	Ruhe = 1;
    if (!Ruhe)
	Banner();

	// Find file size.
    fseek(f, 0, SEEK_END);
    p = ftell(f);
    fseek(f, 0, SEEK_SET);
	// Go!
    out =fopen("3DSR.foe","w");
    if (!Ruhe) fprintf(out,"Filename : \"%s\"\n",argv[1]);
    ChunkReader(f, 0, p);

//-----------ausgabe
    for (i=0;i<strlen(argv[1])-4;i++) hilfname[i]=argv[1][i];
    hilfname[i]='\0';
    strcat(hilfname,".mat");
    out =fopen(hilfname,"w");
    fprintf(out,"Filename : \"%s\"\n\n",argv[1]);

/*
    for (p=0;p<OBJ_nr;p++)
     printf("nr:=%ld %Fs aVert:=%d eVert:=%d aFaces:=%d eFaces:=%d \n",p,
	 OBJ_name[p],OBJ_aeVertices[p][0],OBJ_aeVertices[p][1],OBJ_aeFaces[p][0],
	 OBJ_aeFaces[p][1]);

    for (p=0;p<VERT_nr;p++)
     printf("nr:=%ld x:=%f y:=%f z:=%f u:=%f v:=%f \n",p,VERT_xyzuv[p][0],VERT_xyzuv[p][1],VERT_xyzuv[p][2]
	     ,VERT_xyzuv[p][3],VERT_xyzuv[p][4]);

    for (p=0;p<FACE_nr;p++)
     printf("nr:=%ld A:=%d B:=%d C:=%d \n",p,FACE_123[p][0],FACE_123[p][1],FACE_123[p][2]);

    for (p=0;p<FACE_nr;p++)
     printf("nr:=%ld %Fs \n",p,FACE_matname[p]);
*/
//  out=stdout;
    fprintf(out,"MAT_anzahl    =%d\n",MAT_nr);
    for (p=0;p<MAT_nr;p++){
	fprintf(out,"MAT_name      =%Fs\n",MAT_name[p]);
	fprintf(out,"MAT_map_anzahl=%d\n",MAT_map_nr[p]);
	    for (i=0;i<MAT_map_nr[p];i++){
	      j=0;
	      if (_fstrcmp(MAT_maptype[p][i],"Texture map 1")==0){
		fprintf(out,"Maptype       =TEXTURE\n");//MAT_maptype[p][i]);
		fprintf(out,"Mapfile       =%Fs\n",MAT_mapfile[p][i]);
		j++;
		}
	      if (_fstrcmp(MAT_maptype[p][i],"Texture map 2")==0){
		fprintf(out,"Maptype       =TRANZ_TEXTURE\n");
		fprintf(out,"Mapfile       =%Fs\n",MAT_mapfile[p][i]);
		j++;
		}
	      if (_fstrcmp(MAT_maptype[p][i],"Bump map")==0){
		fprintf(out,"Maptype       =Bump\n");
		fprintf(out,"Mapfile       =%Fs\n",MAT_mapfile[p][i]);
		j++;
		}
	      if (_fstrcmp(MAT_maptype[p][i],"Reflection map")==0){
		fprintf(out,"Maptype       =Phong\n");
		fprintf(out,"Mapfile       =%Fs\n",MAT_mapfile[p][i]);
		j++;
		}
		if (j==0){
		  fprintf(out,"%Fs hat eine unerlaubte map (%Fs) \n",
			MAT_name[p],MAT_maptype[p][i]);
		  fehler++;
		}
	    }
    }
  if (fehler!=0) {
    printf("%d Fehler aufgetreten !\n",fehler);
  }
printf("%d %d ",FACE_nr,VERT_nr);
}

